"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// RxJS v6+
const rxjs_1 = require("rxjs");
class MySubject {
    constructor() {
        this.someData = "";
    }
    handleEvent(someEvent) {
        this.someData += someEvent;
    }
    handleEventEvent(someEvent, otherEvent) {
    }
}
function setupObservableSubect() {
    let theSubject = new MySubject();
    const subjectObserver = rxjs_1.Observable.create(observer => {
        observer.next("Hello world, ");
    });
    subjectObserver.subscribe(theSubject.handleEvent);
    subjectObserver.unsubscribe();
}
exports.setupObservableSubect = setupObservableSubect;
/*
  Increment value every 1s, emit even numbers.
*/
function setupObservableCounter() {
    const evenNumbers = rxjs_1.Observable.create(function (observer) {
        let value = 0;
        const interval = setInterval(() => {
            if (value % 2 === 0) {
                observer.next(value);
            }
            value++;
        }, 1000);
        return () => clearInterval(interval);
    });
    //output: 0...2...4...6...8
    const subscribe = evenNumbers.subscribe(val => console.log(val));
    //unsubscribe after 10 seconds
    setTimeout(() => {
        subscribe.unsubscribe();
    }, 10000);
}
exports.setupObservableCounter = setupObservableCounter;
//# sourceMappingURL=Observers-and-Subscribers.js.map