﻿// RxJS v6+
import { Observable } from 'rxjs';

class MySubject
{
    private someData: string = "";

    public handleEvent(someEvent: any): void
    {
        this.someData += <string>someEvent;
    }

    public handleEventEvent(someEvent: any, otherEvent: any)
    {

    }
}

export function setupObservableSubect()
{
    let theSubject: MySubject = new MySubject();

    const subjectObserver = Observable.create(observer => {
        observer.next("Hello world, ");
    });

    subjectObserver.subscribe(theSubject.handleEvent);

    subjectObserver.unsubscribe();
}


/*
  Increment value every 1s, emit even numbers.
*/
export function setupObservableCounter()
{
    const evenNumbers = Observable.create(function (observer)
    {
        let value = 0;
        const interval = setInterval(() =>
        {
            if (value % 2 === 0)
            {
                observer.next(value);
            }
            value++;
        }, 1000);

        return () => clearInterval(interval);
    });
    //output: 0...2...4...6...8
    const subscribe = evenNumbers.subscribe(val => console.log(val));
    //unsubscribe after 10 seconds
    setTimeout(() => {
        subscribe.unsubscribe();
    }, 10000);
}


